unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ScktComp;

type
  Twebio_ascii_server = class(TForm)
    gb_io: TGroupBox;
    bt_counter_readall: TButton;
    bt_counter_clearall: TButton;
    lb_counterall: TLabel;
    bt_inputs_read: TButton;
    bt_outputs_read: TButton;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    Label1: TLabel;
    ed_interval: TEdit;
    gb_connection: TGroupBox;
    ed_port: TEdit;
    bt_listen: TButton;
    bt_listenstop: TButton;
    StatusBar1: TStatusBar;
    timer_polling: TTimer;
    ed_password: TEdit;
    lb_port: TLabel;
    lb_password: TLabel;
    ServerSocket1: TServerSocket;
    procedure bt_listenClick(Sender: TObject);
    procedure bt_listenstopClick(Sender: TObject);
    procedure bt_outputs_readClick(Sender: TObject);
    procedure bt_inputs_readClick(Sender: TObject);
    procedure bt_counter_readallClick(Sender: TObject);
    procedure bt_counter_clearallClick(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure ed_intervalChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServerSocket1Listen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1Accept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure outputset(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    procedure ReadCounter(Sender: TObject);
    procedure ClearCounter(Sender: TObject);
  end;

const
  MAXI=11;
  MAXO=11;

  BITSET : array [0..11] of longword =
      ( 1, 2, 4, 8,
        $10, $20, $40, $80,
        $100, $200, $400, $800);

  OUTSET : array [0..11] of String =
      ( '0001', '0002', '0004', '0008',
        '0010', '0020', '0040', '0080',
        '0100', '0200', '0400', '0800');

var
  webio_ascii_server: Twebio_ascii_server;
  cb_output : array [0..MAXO] of tcheckbox;
  cb_input : array [0..MAXI] of tcheckbox;
  lb_counter : array [0..MAXI] of tlabel;
  ed_counter : array [0..MAXI] of tedit;
  bt_counterread : array [0..MAXI] of tButton;
  bt_counterclear : array [0..MAXI] of tButton;

implementation
{$R *.DFM}

function HexToInt(HexString : String) : longWord;
var CharCount           : integer;
    HexCharValue        : longWord;
    HexValue            : longWord;
begin
   HexValue := 0;
   HexString := UpperCase(HexString);
   for CharCount := 1 to length(HexString) do
   begin
     HexCharValue := ord(HexString[CharCount]);
     if HexCharValue > 57 then
        HexCharValue := HexCharValue - 55
     else
        HexCharValue := HexCharValue - 48;
     HexCharValue := HexCharValue shl ((length(HexString) - CharCount) *  4);
     HexValue := HexValue or HexCharValue;
   end;
   HexToInt := HexValue;
end;

procedure Twebio_ascii_server.FormCreate(Sender: TObject);
var
  dummycount : word;
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_listenstop.Enabled := False;
  gb_io.Enabled := False;
  for dummycount := 0 to MAXO do
  begin
    cb_output[dummycount] := tcheckbox.create(gb_io);
    with cb_output[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=73;
      height:=17;
      checked :=false;
      Left:=16;
      top:=24 + dummycount * 24;
      caption := 'Output' + inttostr(dummycount);
      onMouseUp := Outputset;
    end;
  end;
  for dummycount := 0 to MAXI do
  begin
    cb_input[dummycount] := tcheckbox.create(gb_io);
    with cb_input[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=73;
      height:=17;
      checked :=false;
      Left:=104;
      top:=24 + dummycount * 24;
      caption := 'Input' + inttostr(dummycount);
    end;
    lb_counter[dummycount] := tlabel.create(gb_io);
    with lb_counter[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=73;
      height:=17;
      Left:=184;
      top:=24 + dummycount * 24;
      caption := 'Counter' + inttostr(dummycount);
    end;
    ed_counter[dummycount] := tedit.create(gb_io);
    with ed_counter[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=65;
      height:=21;
      Left:=240;
      top:=18 + dummycount * 24;
      Text := '0';
    end;
    bt_counterread[dummycount] := tbutton.create(gb_io);
    with bt_counterread[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=49;
      height:=25;
      Left:=312;
      top:=16 + dummycount * 24;
      caption := 'Read';
      onclick := ReadCounter;
    end;
    bt_counterclear[dummycount] := tbutton.create(gb_io);
    with bt_counterclear[dummycount] do
    begin
      parent := gb_io;
      visible := true;
      Width:=49;
      height:=25;
      Left:=368;
      top:=16 + dummycount * 24;
      caption := 'Clear';
      onclick := ClearCounter;
    end;
  end;
end;

procedure Twebio_ascii_server.bt_listenClick(Sender: TObject);
begin
  If ed_port.Text <> '' Then
  begin
    ServerSocket1.Port := strtoint(ed_port.Text);
    ServerSocket1.Open;
  end
  Else ShowMessage ('No local port!');
end;

procedure Twebio_ascii_server.ServerSocket1Listen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Listening';
  gb_io.Enabled := False;
  bt_listenstop.Enabled := true;
  bt_listen.Enabled := false;
end;

procedure Twebio_ascii_server.ServerSocket1Accept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Connected to ' + Socket.RemoteAddress;
  gb_io.Enabled := True;
  //btDisconnect.Enabled := True;
end;

procedure Twebio_ascii_server.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if ServerSocket1.Socket.ActiveConnections > 1 then
    Socket.Close
  else
    ServerSocket1.Socket.Connections[0].SendText('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.bt_listenstopClick(Sender: TObject);
begin
  ServerSocket1.Close;
  bt_listenstop.Enabled := false;
  bt_listen.Enabled := true;
end;

procedure Twebio_ascii_server.ServerSocket1ClientDisconnect(
  Sender: TObject; Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Listening';
  ServerSocket1.Open;
  gb_io.Enabled := False;
  bt_listenstop.Enabled := true;
end;

procedure Twebio_ascii_server.bt_outputs_readClick(Sender: TObject);
begin
  ServerSocket1.Socket.Connections[0].SendText('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.bt_inputs_readClick(Sender: TObject);
begin
  ServerSocket1.Socket.Connections[0].SendText('GET /input?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.bt_counter_readallClick(Sender: TObject);
begin
  ServerSocket1.Socket.Connections[0].SendText('GET /counter?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_server.bt_counter_clearallClick(Sender: TObject);
begin
  ServerSocket1.Socket.Connections[0].
      SendText('GET /counterclear?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_server.outputset(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var dummycount : word;
    outputno : word;
begin
  for dummycount := 0 to MAXO do
    if sender = cb_output[dummycount] then outputno := dummycount;
  if cb_output[outputno].Checked then
    ServerSocket1.Socket.Connections[0].SendText('GET /outputaccess?PW=' + ed_password.Text
    + '&Mask=' + OUTSET[outputno] + '&State=' + OUTSET[outputno] + '&')
  else
    ServerSocket1.Socket.Connections[0].SendText('GET /outputaccess?PW=' + ed_password.Text
    + '&Mask=' + OUTSET[outputno] + '&State=0000&');
end;

procedure Twebio_ascii_server.ReadCounter(Sender: TObject);
var dummycount : word;
begin
  for dummycount := 0 to MAXI do
    if sender = bt_counterread[dummycount] then
    ServerSocket1.Socket.Connections[0].SendText('GET /counter'
    + inttostr(dummycount)+'?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.ClearCounter(Sender: TObject);
var dummycount : word;
begin
  for dummycount := 0 to MAXI do
    if sender = bt_counterclear[dummycount] then
    ServerSocket1.Socket.Connections[0].SendText('GET /counterclear'
    + inttostr(dummycount)+'?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var ReceiveString : String;
    HexValue : word;
    dummycount : word;
begin
  ReceiveString := Socket.ReceiveText;
  if Receivestring[1] = 'o' then //Output-Meldungen auswerten
  begin
    HexValue := HextoInt(copy(ReceiveString,
      pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)-1));
    for dummycount := 0 to MAXO do
    if HexValue and BITSET[dummycount] > 0 then
      cb_output[dummycount].Checked := True
    else
      cb_output[dummycount].Checked := false;
  end;
  if Receivestring[1] = 'i' then //Input-Meldungen auswerten
  begin
    HexValue := HextoInt(copy(ReceiveString,
       pos(';',ReceiveString)+1,
       length(ReceiveString)-pos(';',ReceiveString)-1));
    for dummycount := 0 to MAXI do
    if HexValue and BITSET[dummycount] > 0 then
      cb_input[dummycount].Checked := True
    else
      cb_input[dummycount].Checked := false;
  end;
  if Receivestring[1] = 'c' then //Counter-Meldungen auswerten
  begin
    if pos(';',ReceiveString) = 9 then //Counter0 bis Counter9
      ed_counter[strtoint(copy(ReceiveString, 8, 1))].text :=
        copy(ReceiveString, 10,length(ReceiveString)-10);
    if pos(';',ReceiveString) = 10 then //Counter10 bis Counter11
      ed_counter[strtoint(copy(ReceiveString, 8, 2))].text :=
        copy(ReceiveString, 11,length(ReceiveString)-11);
    if pos(';',ReceiveString) = 8 then //alle Counter zusammen
    begin
      for dummycount := 0 to MAXI - 1 do
      begin
        delete(ReceiveString, 1, pos(';',ReceiveString));
        ed_counter[dummycount].text :=
          copy(ReceiveString, 1,pos(';',ReceiveString)-1);
      end;
      delete(ReceiveString, 1, pos(';',ReceiveString));
      ed_counter[MAXI].text := copy(ReceiveString, 1,length(ReceiveString)-1);
    end;
  end;
end;

procedure Twebio_ascii_server.timer_pollingTimer(Sender: TObject);
begin
  if (ServerSocket1.Socket.ActiveConnections > 0) and cb_output_polling.Checked then
    ServerSocket1.Socket.Connections[0].SendText('GET /output?PW=' + ed_password.Text + '&');
  if (ServerSocket1.Socket.ActiveConnections > 0) and cb_input_polling.Checked then
    ServerSocket1.Socket.Connections[0].SendText('GET /input?PW=' + ed_password.Text + '&');
  if (ServerSocket1.Socket.ActiveConnections > 0) and cb_counter_polling.Checked then
    ServerSocket1.Socket.Connections[0].SendText('GET /counter?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_server.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval := strtoint(ed_interval.Text);
end;

end.
